package com.jkcredit.sysnews.service.navigationBar;

import com.jkcredit.sysnews.mapper.NavigationBarMapper;
import com.jkcredit.sysnews.model.dto.navigationBar.NavigationBarDto;
import com.jkcredit.sysnews.model.po.navigationBar.NavigationBarPo;
import com.jkcredit.sysnews.service.base.BaseService;
import com.jkcredit.sysnews.spi.lang.exception.ServiceException;
import com.jkcredit.sysnews.util.BeanUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * @description:
 * @author: xusonglin
 * @create: 2020/3/8 23:59
 * @version: V1.0
 **/
@Slf4j
@Service
@Transactional(readOnly = true)
public class NavigationBarServiceImpl extends BaseService implements NavigationBarService {
    @Resource
    NavigationBarMapper navigationBarMapper;

    @Override
    @Transactional(rollbackFor = ServiceException.class)
    public void saveNavigationBar(List<NavigationBarDto> navigationBarDtoList) {
        try {
            validate(navigationBarDtoList);
            for (NavigationBarDto navigationBarDto : navigationBarDtoList) {
                NavigationBarPo navigationBarPo = new NavigationBarPo();
                BeanUtil.copyProperties(navigationBarPo, navigationBarDto);
                navigationBarPo.setCreateTime(new Date());
                navigationBarMapper.insert(navigationBarPo);
            }
        } catch (Exception e) {
            log.error("新增菜单栏失败，失败原因：{}", e.getMessage());
            throw new ServiceException("新增菜单栏失败");
        }
    }
}
